package Chasen;
$VERSION = "1.3.2";

=head1 NAME

Chasen - Chasen Client class

=head1 SYNOPSIS

    BEGIN { push(@INC, '/home/is/masana-i/lib/perl'); }
    use Chasen;

    $chasen = Chasen->new('lunlun', 31000);
    @words = $chasen->run('䥤Ǥ');
    @yomi  = $chasen->run('䥤Ǥ', '%y');
    $chasen->quit;

=item new (HOST, PORT)

䥥Ф³롥Ԥȡundef ֤ޤ

=item run (TEXT [, FORMAT])

ǲϤԤʤη̤ññ̤ΥꥹȤȤ֤ޤ

=item quit

䥥ФȤ³ڤޤ

=item remove_EOS

 0 ꤹȡϷ̤ EOS ̵뤷ޤ 1 ꤹȡ
Ϸ̤ EOS ϤΤޤޤˤʤޤǥեȤǤϡϷ̤ EOS ̵뤹
褦ˤʤäƤޤ

=cut


use Socket;
my $chasen_default_format = '%m';

sub new
{
    my $type = shift;
    my($host, $port) = @_;
    my $chasen = bless {};
    my($addr, $proto, $s, $fiz);

    $fiz = $chasen->{'SERVER'} = "$chasen";

    if($host =~ /^[0-9.]+$/)
    {
	$addr = sockaddr_in($port, inet_aton($host));
    }
    else
    {
	my $iaddr;
	$iaddr = gethostbyname($host) || return undef;
	$addr = sockaddr_in($port, $iaddr);
    }

    $proto = getprotobyname('tcp');

    socket($fiz, PF_INET, SOCK_STREAM, $proto) || return undef;

    connect($fiz, $addr) || return undef;

    $s = select($fiz); $| = 1; select($s);
    chomp($chasen->{'SERVER_VERSION'} = $chasen->getline) || return undef;
    $chasen->{'REMOVE_EOS'} = 1;
    $chasen;
}

sub run
{
    my $chasen = shift;
    my $text = shift;
    my $format = @_ ? join(' ', @_) : $chasen_default_format;
    my $status;

    $chasen->command('RUN', '-F', &escape_space($format));
    $chasen->write_text($text);

    $status = $chasen->getline;
    return undef if $status !~ /^200/;
    $chasen->read_text;
}

sub quit
{
    my $chasen = shift;

    $chasen->command('QUIT');
    close($chasen->{'SERVER'});
}

sub command
{
    my $chasen = shift;
    my $fiz = $chasen->{'SERVER'};
    print $fiz join(' ', @_) . "\n";
}

sub getline
{
    my $chasen = shift;
    my $fiz = $chasen->{'SERVER'};
    <$fiz>;
}

sub read_text
{
    my $chasen = shift;
    my @lines;
    my $rmeos = $chasen->{'REMOVE_EOS'};

    while(1)
    {
	chomp($_ = $chasen->getline);
	next if $_ eq 'EOS' && $rmeos;
	last if /^\.$/;
	s/^\.\././;
	push(@lines, $_);
    }
    @lines;
}

sub remove_EOS
{
    my $chasen = shift;
    $chasen->{'REMOVE_EOS'} = @_[0];
}

sub write_text
{
    my $chasen = shift;
    my $text = &normalize_text(shift);
    my $fiz = $chasen->{'SERVER'};

    for(split("\n", $text))
    {
	s/^\./../;
	print $fiz $_, "\n" if $_;
    }
    print $fiz ".\n";
}

sub normalize_text
{
    my($text) = @_;

    # ñˤ뤿ᡤEUC ɤƬˡ\034 롥
    $text =~ s/([\241-\376][\241-\376])/\034\1/g;

    # ѥڡȾѥڡ
    $text =~ s/\141\141/ /g;

    # ʣζϰĤ
    $text =~ tr/ \n\t/ /s;

    # ƬζϺ
    $text =~ s/^ | $//g;

    # ܸʸκζϺ
    $text =~ s/ (\034[\241-\376])/\1/g;
    $text =~ s/([\241-\376][\241-\376]) /\1/g;

    # ʸνǲ
    # \xa1\xa3 ()
    # \xa1\xa5 ()
    # \xa1\xa9 ()
    # ([][.])
    $text =~ s/(\xa1\xa3|\xa1\xa5|\xa1\xa9|[\241-\376]\.)/\1\n/g;

    # ᤹
    $text =~ s/\034([\241-\376][\241-\376])/\1/g;
    $text;
}

sub escape_space
{
    my($string) = @_;

    $string =~ s/ /\\ /g;
    $string;
}
1;
