#include <stdio.h>
#include <string.h>

int skip_until_dot(FILE* fp);
int read_until_dot(char* buff, int bufsiz, FILE* fp);

#ifdef sun
#define memmove(a, b, n) bcopy(b, a, n)
#endif /* sun */

int read_until_dot(char* buff, int bufsiz, FILE* fp)
{
    int len, restsiz, readsiz;
    int bolp; /* true if beginning of line */
    char* begp;

    restsiz = bufsiz;
    readsiz = 0;
    begp = buff;
    bolp = 1;

    /* Note: restsiz > 1 for '\0' */
    while(restsiz > 1 && fgets(buff, restsiz, fp) != NULL)
    {
	len = strlen(buff);

	/* CRLF -> LF */
	if(len > 1 && buff[len - 2] == '\r' && buff[len - 1] == '\n')
	{
	    buff[len - 2] = '\n';
	    buff[len - 1] = '\0';
	    len--;
	}

	if(bolp)
	{
	    /* .\n */
	    if(buff[0] == '.' && buff[1] == '\n')
		break;

	    /* .. -> . */
	    if(buff[0] == '.' && buff[1] == '.')
	    {
		memmove(buff, buff + 1, len); /* remove byte stuffed '.' */
		len--;
	    }
	}

	bolp = (len > 0 && buff[len - 1] == '\n');
	buff += len;
	restsiz -= len;
    }

    *buff = '\0';

    if(restsiz <= 1)
	skip_until_dot(fp);

    return buff - begp;
}

int skip_until_dot(FILE* fp)
{
    char buff[BUFSIZ];
    while(fgets(buff, BUFSIZ, fp))
    {
	if(buff[0] == '.' &&
	   (buff[1] == '\n' || (buff[1] == '\r' && buff[2] == '\n')))
	    break;
    }
}
